#!ruby -Ks

require 'vr/vruby'
#require 'vr/vrcontrol'
#require 'vr/vrcomctl'
require 'vr/vrlayout2'
require 'vr/vrtvitem'
require 'vr/vrdialog'	#VRModalDialog
#require 'vr/vrhandler'

require 'uconv'


require 'olex_base.rb'
require 'gridcanvas.rb'


class SheetViewPanel < GridCanvasPanel
	include VRMouseFeasible
	include VRStdControlContainer
	include VRMessageHandler
	
	def construct
		super
		send_parent("self","lbuttondown")
		send_parent("self","lbuttonup")
		send_parent("self","mousemove") 
	end
	
	def vrinit
		super
	end
	
	def draw_fillRect(da)
		self.canvas.fillRect(*da)
	end
	
	
	def draw_shape(c,da)
		da[0] += offset[0]
		da[1] += offset[1]
		da[2] += offset[0]
		da[3] += offset[1]
		send("draw_#{c.shape}",da)
	end
	
	def draw(c)

		draw_shape(c,c.style.argument)
		tmp_font = @screen.factory.newfont(	c.style.font.name,
											c.style.font.size,
											c.style.font.style )
		self.canvas.setFont(tmp_font)
		self.canvas.textColor = c.style.font.color
		temp_argument = c.style.font_argument
		temp_argument[1] += offset[0]
		temp_argument[2] += offset[1]
		temp_argument[3] += offset[0]
		temp_argument[4] += offset[1]
		
		self.canvas.drawText(*temp_argument)
	end
end


class ShelfTreeview <VRTreeview
	def vrinit
		super
	end
	
end


class SelectMark < Mark
	def mark_up(s)
		s.canvas.setPen(RGB(0,0,0))
		s.canvas.setBrush(RGB(0,0,0))
		
		@marks.each {|m|
			if (m != nil) then
				s.canvas.fillRect(	(m.x+s.offset[0]),(m.y+s.offset[1]),
									(m.x+m.w+s.offset[0]),(m.y+m.h+s.offset[1]))
			end
		}
		s.refresh
	end
end



#ItemPropetyDialog

module Cntn_font_typeface
	include VRStdControlContainer
	include VRMessageParentRelayer

	attr :rBtn_nomal
	attr :rBtn_italic
	attr :rBtn_bold
	attr :rBtn_bold_itali

	def _cntn_init
		vrinit
		f = @screen.factory.newfont("lr SVbN",14)

		addControl(VRRadiobutton,'rBtn_nomal',"W",8,24,88,24).setFont(f)
		addControl(VRRadiobutton,'rBtn_italic',"Α",8,48,88,24).setFont(f)
		addControl(VRRadiobutton,'rBtn_bold',"",8,72,88,24).setFont(f)
		addControl(VRRadiobutton,'rBtn_bold_italic'," Α",8,96,88,24).setFont(f)
		@rBtn_nomal.check(true)
	end

end

module Cntn_font_underline
	include VRStdControlContainer
	include VRMessageParentRelayer

	attr :rBtn_ul_nomal
	attr :rBtn_ul_single
	attr :rBtn_ul_double

	def _cntn_init
		vrinit
		f = @screen.factory.newfont("lr SVbN",14)
		
		addControl(VRRadiobutton,'rBtn_ul_nomal',"",8,24,96,24).setFont(f)
		addControl(VRRadiobutton,'rBtn_ul_single',"",8,48,96,24).setFont(f)
		addControl(VRRadiobutton,'rBtn_ul_double',"d",8,72,96,24).setFont(f)
		@rBtn_ul_nomal.check(true)
	end

end

module Cntn_font
	include VRStdControlContainer
	include VRMessageParentRelayer

	attr :underline
	attr :typeface

	def _cntn_init
		vrinit
		
		addControl(VRGroupbox,'underline',"",120,24,112,128)
		@underline.extend(Cntn_font_underline)._cntn_init
		addControl(VRGroupbox,'typeface',"",8,24,104,128)
		@typeface.extend(Cntn_font_typeface)._cntn_init
	end

end



class BasePropetyDialog < VRModalDialog
	
	@@folder = nil
	@@sheet = nil
#	@@x = nil
#	@@y = nil
	def BasePropetyDialog.folder= (folder);@@folder = folder end
	def BasePropetyDialog.sheet= (sheet);@@sheet = sheet end
#	def BasePropetyDialog.x= (x);@@x = x end
#	def BasePropetyDialog.y= (y);@@y = y end
	
	def initialize
		super
		@folder = @@folder
		@sheet = @@sheet
#		@x = @@x
#		@y = @@y
	end
	
	def construct
		f = @screen.factory.newfont("lr SVbN",14)
		
		addControl(VRStatic,'static1',"OF",20,20,60,20).setFont(f)
		addControl(VREdit,'name',@folder.name,80,20,400,20).setFont(f)
	
		addControl(VRStatic,'static2',"\",20,40,60,20).setFont(f)
		addControl(VRCheckbox,'checkBox_folder',"tH_",80,40,80,20).setFont(f)
		addControl(VRCheckbox,'checkBox_card',"J[h",80,60,60,20).setFont(f)
	
		addControl(VRStatic,'static7',"tHg",220,40,80,20).setFont(f)
		addControl(VRStatic,'static',"TCYF",320,40,80,20).setFont(f)
		addControl(VREdit,'font_size',@folder.style.font.size.to_s,380,40,60,20).setFont(f)
		addControl(VRUpdown,'updown_fsize',"updown5",0,0,0,0, WStyle::UDS_INTBUDDYRIGHT).setFont(f)
		@updown_fsize.setRange(0,100)
		@updown_fsize.position = @folder.style.font.size
	
		addControl(VRStatic,'static3',"F",4,80,26,20).setFont(f)
		addControl(VREdit,'x',@folder.style.x,40,80,60,20).setFont(f)
		addControl(VRUpdown,'updown_x',"updown",0,0,0,0, WStyle::UDS_INTBUDDYRIGHT).setFont(f)
		@updown_x.setRange(0,1000)
		@updown_x.position=(@folder.style.x)
#		@updown_x.position=@sheet.grid.x_index(@folder.style.x)
#		@x_pos = @updown_x.position
        
		addControl(VRStatic,'static4',"cF",4,100,26,20).setFont(f)
		addControl(VREdit,'y',@folder.style.y,40,100,60,20).setFont(f)
		addControl(VRUpdown,'updown_y',"updown_y",0,0,0,0, WStyle::UDS_INTBUDDYRIGHT).setFont(f)
		@updown_y.setRange(0,1000)
		@updown_y.position=(@folder.style.y)
#		@updown_y.position=@sheet.grid.y_index(@folder.style.y)

		addControl(VRStatic,'static5',"F",104,80,26,20).setFont(f)
		addControl(VREdit,'w',@folder.style.w,140,80,60,20).setFont(f)
		addControl(VRUpdown,'updown_w',"updown_w",0,0,0,0, WStyle::UDS_INTBUDDYRIGHT).setFont(f)
		@updown_w.setRange(0,1000)
		@updown_w.position=(@folder.style.w)
#		@updown_w.position=	@sheet.grid.x_index(@folder.style.x+@folder.style.w)-
#							@sheet.grid.x_index(@folder.style.x)

		addControl(VRStatic,'static6',"F",104,100,26,20).setFont(f)
		addControl(VREdit,'h',@folder.style.h,140,100,60,20).setFont(f)
		addControl(VRUpdown,'updown_h',"updown_h",0,0,0,0, WStyle::UDS_INTBUDDYRIGHT).setFont(f)
		@updown_h.setRange(0,1000)
		@updown_h.position=(@folder.style.h)
#		@updown_h.position=	@sheet.grid.y_index(@folder.style.y+@folder.style.h)-
#							@sheet.grid.y_index(@folder.style.y)


		addControl(VRGroupbox,'font',"",240,60,240,160)
		@font.extend(Cntn_font)._cntn_init
	
		addControl(VRStatic,'static8',"eLXg",32,240,72,24).setFont(f)
		addControl(VRText,"text",@folder.text,32,272,416,48,WStyle::WS_VSCROLL).setFont(f)
	
		addControl(VRButton,'okbtn',"OK",296,328,80,24).setFont(f)
		addControl(VRButton,'cancelbtn',"Cancel",384,328,80,24).setFont(f)
		
		@dialog_w = 500
		@dialog_h = 400
		move(0,0,@dialog_w,@dialog_h)
		centering

	end
	
	def okbtn_clicked
		@folder.name = @name.caption
		@folder.text = @text.caption
		
		@folder.style.x = @x.caption.to_i
		@folder.style.y = @y.caption.to_i
		@folder.style.w = @w.caption.to_i
		@folder.style.h = @h.caption.to_i
		
		@folder.style.font.size = @font_size.caption.to_i
		close(@folder)
	end
	
	def cancelbtn_clicked
		close(@folder)
	end

end



class ItemPropetyDialog < BasePropetyDialog
	

end


#####################################

class MyForm < VRForm
	include VRResizeable
	include VRMenuUseable
	include VRStdControlContainer
	
	attr_accessor :folderHash
	attr_accessor :shelfTreeview
	
	def construct
	    self.caption = "OLeX"
		
		
		#EyClabel\BOXtext\BOX쐬
		
		addControl(SheetViewPanel,"sheetView","canvas",
					0,0,400,400,WStyle::WS_VSCROLL|WStyle::WS_HSCROLL)
		addControl(VRText,"noteView","",10,0,10,10,WStyle::WS_VSCROLL)
		
#		@sheetView.createCanvas(800,600)
		@sheetView.reset
		
		@k1=VRVertTwoPaneFrame.new(@sheetView,@noteView).setup(self)
		
		
		#yCFolder \TreeView쐬
		
		addControl(ShelfTreeview,"shelfTreeview","node")
		@k =VRHorizTwoPaneFrame.new(@shelfTreeview,@k1).setup(self)
		
		#menu Item쐬
		setMenu newMenu.set( [
			["t@C",[
				["VK쐬","menu_new"],
				["J","menu_open"],
				["","menu_close"],
				["㏑ۑ","menu_saveas"],
				["Oĕۑ","menu_save"]
			]],
			["ҏW",[
				["ɖ߂","menu_undo"],
				VRMenu::SEPARATOR,
				["Jbg","menu_cut"],
				["Rs[","menu_copy"],
				["N[","menu_clone"],
				["y[Xg","menu_paste"]
			]],
			["tH_",[
				["̃xɃtH_ǉ","menu_folder_insert"],
				["xɃtH_ǉ","menu_folder_add"],
				["tH_vpeB","menu_folder_propety"],
				["tH_폜","menu_folder_delete"]
			]],
			["J[h",[
				["J[hvpeB","menu_card_propety"],
				["J[h폜","menu_card_delete"]
			]],
			["wv",[
				["wv","menu_help"],
				["o[W","menu_version"]
		]]])
		
		#roottH_쐬(TreeItemkeyƂāAItemlƂHashŊǗ)
		
		@itemHash = Hash.new
		@rootFolder = Item.new(:folder,"root")
		
		@rootTreeItem = 
			@shelfTreeview.insertItem(WConst::TVI_ROOT,WConst::TVI_LAST,@rootFolder.name,0)
			
		@shelfTreeview.setItemStateOf(@rootTreeItem,32) 
		@itemHash[@rootTreeItem] = @rootFolder
		
		@mark = nil
		
		@sheetView_flag = :no_no
			#:no_no :on_card :select_card :on_mark :select_mark
		
		@selected_card = nil	#SheetView̑IꂽJ[h
		
		@filename = nil
		
		@mouse_x = nil
		@mouse_y = nil
	end
	
	attr_accessor :sheetView
	
	def sheetView_reset(folder)
		@sheetView.reset
		
		@sheetView.canvas.setPen(RGB(0,0,0))
		@sheetView.canvas.setBrush(RGB(0xff,0xff,0xff))
		if (folder.items != nil) then
			folder.items.reverse_each { |c|
				@sheetView.draw(c)
			}
		end
		@sheetView.refresh
		@noteView.caption = ""
	
	end
	
	
	def sheetView_self_lbuttondown(shift,x,y)
		
		if (@shelfTreeview.selectedItem == nil) then
			return
		end
		
		if (shift == 1) then
			pfolder = @itemHash[@shelfTreeview.selectedItem]
			sheetView_reset(pfolder)
			
			if (pfolder.items.size != 0) then
				pfolder.items.each {|f|
					if (x.between?((f.style.x+@sheetView.offset[0]),(f.style.x+f.style.w+@sheetView.offset[0]))) then
						if (y.between?((f.style.y+@sheetView.offset[1]),(f.style.y+f.style.h+@sheetView.offset[1]))) then
							@mark = SelectMark.new(f)
							@mark.mark_up(@sheetView)
							
							@sheetView_flag = :select_card
							@selected_card = f
							@noteView.caption = f.note
							@mouse_x = x
							@mouse_y = y
							break
						end
					end
					@sheetView_flag = :no_no
					@selected_card = nil
					sheetView_reset(pfolder)
					@noteView.caption = pfolder.note
				}
			else
				@sheetView_flag = :no_no
				@selected_card = nil
				sheetView_reset(pfolder)
				@noteView.caption = pfolder.note
			end
		else
		end
	end
	
	def sheetView_self_lbuttonup(shift,x,y)
#		pfolder = @itemHash[@shelfTreeview.selectedItem]
#		if (shift == 1) then
#			@sheetView_flag = :no_no
#			sheetView_reset(pfolder.cards)
#		end
	end
	
	def sheetView_self_mousemove(shift,x,y)
#		pfolder = @itemHash[@shelfTreeview.selectedItem]
#		if (shift == 1) then
#			@sheetView_flag = :no_no
#			@mouse_x = x
#			@mouse_y = y
#			sheetView_reset(pfolder.cards)
#		end
	end
	
	def shelfTreeview_selchanged(hitem,lparam)
		pfolder = @itemHash[hitem]
		sheetView_reset(pfolder)
		@noteView.caption = pfolder.note
	end
	
	def noteView_changed
		if (@selected_card != nil) then
			i = @selected_card
		elsif (@shelfTreeview.selectedItem != nil)
			i = @itemHash[@shelfTreeview.selectedItem]
		else
			return
		end
		i.note = @noteView.caption
	end
	
	def menu_open_clicked
		def shelfTreeview_reset(pitem,phitem)
			pitem.items.each{|e|
				i = @shelfTreeview.addItem(phitem,e.name)
				@itemHash[i] = e
				@shelfTreeview.setItemStateOf(i,32) 
				if (0 <e.items.size) then
					shelfTreeview_reset(e,i)
				end
				
			}
		end
		
		@filename=SWin::CommonDialog::openFilename(self,[ ["OLeX file","*.olx"] ])
		if (@filename != nil) then
			open(@filename, "rb"){ |io|
			n = Marshal.load(io)
			name = Uconv.u8tosjis(n)
			version = Marshal.load(io)
				@rootFolder.load(io)
			}
			self.caption = "OLeX" + " " + @filename.to_s
			
			@shelfTreeview.clearItems
			
			@rootTreeItem = 
				@shelfTreeview.insertItem(WConst::TVI_ROOT,WConst::TVI_LAST,@rootFolder.name,0)
			@shelfTreeview.setItemStateOf(@rootTreeItem,32) 
			
			@itemHash[@rootTreeItem] = @rootFolder
			if (@rootFolder.items != nil) then
				shelfTreeview_reset(@rootFolder,@rootTreeItem)
			end
		end
	end
	
	
	def menu_save_clicked
		@filename = nil
		@filename=SWin::CommonDialog::saveFilename(self,[ ["OLeX file","*.olx"] ])
		if(@filename != nil) then
			@filename +=".olx" if (File.extname(@filename) != ".olx")
			open(@filename, "wb"){ |io|
				Marshal.dump("OLex",io)
				Marshal.dump("00000000",io)
				@rootFolder.save(io)
			}
		end
	end
	
	def menu_saveas_clicked
		if(@filename == nil) then
			menu_save_clicked
		else
			open(@filename, "wb"){ |io|
				Marshal.dump("OLex",io)
				Marshal.dump("00000000",io)
				@rootFolder.save(io)
			}
		end
	end
	
	def menu_folder_insert_clicked
		if (@shelfTreeview.selectedItem == nil) then
			return nil
		else
			p = @shelfTreeview.selectedItem
			f = Item.new(:item,"insert Item",:fillRect,@itemHash[p])
			f.style.w = (f.text.size * f.style.font.size / 8) * 8 + 8
			f.style.h = (f.style.font.size / 8) * 8 + 8
			i = @shelfTreeview.addItem(p,f.name)
			@shelfTreeview.setItemStateOf(i,32) 
			
			#TreeItemkeyƂāAFolderlƂHashŊǗ
			@itemHash[p].insert(f)
			@itemHash[i] = f
			
			shelfTreeview_selchanged(p,0)
		end
	end

	def menu_folder_add_clicked
		if (@shelfTreeview.selectedItem == nil) then
			return nil
		elsif (@shelfTreeview.getParentOf(@shelfTreeview.selectedItem) == nil) then
			return nil
		else
			s = @shelfTreeview.selectedItem
			p = @shelfTreeview.getParentOf(s)
			f = Item.new(:item,"add Item",:fillRect,@itemHash[p])
			f.style.w = (f.text.size * f.style.font.size / 8) * 8 + 8
			f.style.h = (f.style.font.size / 8) * 8 + 8
			i = @shelfTreeview.addItem(p,f.name)
			@shelfTreeview.setItemStateOf(i,32) 
			
			#TreeItemkeyƂāAFolderlƂHashŊǗ
			#Folder::add()gpƋȂ(2007/08/21)
			@itemHash[p].insert(f)
			@itemHash[i] = f
			
			#@rootFolder.print_folder()
			
		end
	end
	
	def menu_folder_delete_clicked
		if (@shelfTreeview.selectedItem == nil) then
			return nil
		elsif (@shelfTreeview.getParentOf(@shelfTreeview.selectedItem) == nil) then
			return nil
		else
			s = @shelfTreeview.selectedItem
			
			p = @itemHash[s].parent
			p.delete(@itemHash[s])
			@shelfTreeview.deleteItem(s)
			
			#@rootFolder.print_folder()
			
		end
	end
	
	def menu_folder_propety_clicked  	#tH_vpeB_CAOgp
		tmp_i = @shelfTreeview.selectedItem
		item_propety(tmp_i)
	end
	
	def menu_card_propety_clicked  	#J[hvpeB_CAOgp
		if (@selected_card != nil) then
			tmp_i = @itemHash.index(@selected_card)
			item_propety(tmp_i)
			pfolder = @selected_card.parent
			sheetView_reset(pfolder)
		end
	end
	
	def item_propety(i)
		ItemPropetyDialog.folder = @itemHash[i]
		ItemPropetyDialog.sheet = @sheetView
#		ItemPropetyDialog.x = @mouse_x
#		ItemPropetyDialog.y = @mouse_y
		tmp_f =VRLocalScreen.modalform(self,nil,ItemPropetyDialog)
		if (tmp_f.class == Item) then
			@shelfTreeview.setItemTextOf(i,tmp_f.name)
			@itemHash[i] = tmp_f
		end
	end
	
	def menu_version_clicked
		messageBox("OLeX ver. 0.00.0000a"+"\n"+"by Haggy","o[W",0)
	end
	
	def self_resize(w,h)
		@k.move(0,0,w,h)
	end
end


frm=VRLocalScreen.showForm MyForm

VRLocalScreen.messageloop

